<script lang="ts">
    import { ICall } from "./types/call";
    import { createEventDispatcher, onMount } from 'svelte';
    import { saveMock } from './utils';

    export let call: ICall;

    const dispatch = createEventDispatcher();

    enum Tab {
        Headers,
        Response,
        Timing,
        Mock,
    }

    enum HeadersTab {
        General,
        Response,
        Request,
        Payload
    }

    const mockBodyPlaceholder = '{"some":"value"}';
    const mockHeadersPlaceholder = 'Content-Type: application/json';

    let activeTab: Tab = Tab.Headers;
    let accordion: {[index: HeadersTab]: boolean} = {};
    accordion[HeadersTab.General] = true;
    accordion[HeadersTab.Response] = true;
    accordion[HeadersTab.Request] = true;
    accordion[HeadersTab.Payload] = true;

    let timer: NodeJS.Timeout = null;
    $: {
        clearTimeout(timer);
        timer = setTimeout(() => {
            saveMock(call.mock);
        }, 1000);
    }

    let urlWithMatchsHighlighted: string;
    $: {
        try {
            urlWithMatchsHighlighted = call.mock.url.replace(new RegExp(call.mock.regexp, ''), (match) => match ? `<mark>${match}</mark>` : '');
        } catch (e) {
            urlWithMatchsHighlighted = call.mock.url;
        }
    }

    onMount(() => {
    });


</script>

<div class="ks-call">
    <div class="ks-tabs">
        <div on:click|preventDefault={() => dispatch('close')} class="ks-close">x</div>
        <div on:click|preventDefault={() => activeTab = Tab.Headers} class:active={activeTab === Tab.Headers} class="ks-tab">Headers</div>
        <div on:click|preventDefault={() => activeTab = Tab.Response} class:active={activeTab === Tab.Response} class="ks-tab">Response</div>
        <div on:click|preventDefault={() => activeTab = Tab.Timing} class:active={activeTab === Tab.Timing} class="ks-tab">Timing</div>
        <div on:click|preventDefault={() => activeTab = Tab.Mock} class:active={activeTab === Tab.Mock}  class:mock-active={call.mock.active} class="ks-tab">Mock</div>
    </div>

    <div class="ks-content">
        {#if activeTab === Tab.Headers}
            <div class="ks-headers">
                <div class="ks-accordion" class:active={accordion[HeadersTab.General]} on:click={() => accordion[HeadersTab.General] = !accordion[HeadersTab.General]}>General</div>
                {#if accordion[HeadersTab.General]}
                    <div class="ks-p-32">
                        <p><strong>Request URL:</strong> {call.url}</p>
                        <p><strong>Request Method:</strong> {call.method}</p>
                        <p><strong>Status Code:</strong> {call.response.status} {call.response.statusText}</p>
                    </div>
                {/if}

                <div class="ks-accordion" class:active={accordion[HeadersTab.Response]} on:click={() => accordion[HeadersTab.Response] = !accordion[HeadersTab.Response]}>Response Headers</div>
                {#if accordion[HeadersTab.Response]}
                    <div class="ks-p-32">
                        {#each call.response.headers as header}
                            <p><strong>{header.name}:</strong> {header.value}</p>
                        {/each}
                    </div>
                {/if}

                <div class="ks-accordion" class:active={accordion[HeadersTab.Request]} on:click={() => accordion[HeadersTab.Request] = !accordion[HeadersTab.Request]}>Request Headers</div>
                {#if accordion[HeadersTab.Request]}
                    <div class="ks-p-32">
                        {#each call.request.headers as header}
                            <p><strong>{header.name}:</strong> {header.value}</p>
                        {/each}
                    </div>
                {/if}

                {#if call.request.payload !== undefined}
                    <div class="ks-accordion" class:active={accordion[HeadersTab.Payload]} on:click={() => accordion[HeadersTab.Payload] = !accordion[HeadersTab.Payload]}>Request Payload</div>
                    {#if accordion[HeadersTab.Payload]}
                        <div class="ks-p-32">
                            {call.request.payload}
                        </div>
                    {/if}
                {/if}

                <br><br><br><br><br><br><br>
            </div>
        {/if}

        {#if activeTab === Tab.Response}
            <div class="ks-bg-white">
                {call.response.body || ''}
            </div>
        {/if}

        {#if activeTab === Tab.Timing}
            <div class="ks-bg-white">
                {call.time}ms
            </div>
        {/if}

        {#if activeTab === Tab.Mock}
            <div class="ks-bg-white">
                <div>
                    <input type="checkbox" id="mockActive" bind:checked={call.mock.active}>
                    <label for="mockActive">Active</label>
                </div>
                <div>
                    <input type="checkbox" id="mockIsRegexp" bind:checked={call.mock.isRegexp}>
                    <label for="mockIsRegexp">RegExp</label>
                </div>
                {#if call.mock.isRegexp}
                <div>
                    <label for="mockRegexp">RegExp</label>
                    <input type="text" id="mockRegexp" placeholder="\/my\/url\/path\/[^/]*" bind:value={call.mock.regexp}>
                    <span class="regexp-success" class:error={urlWithMatchsHighlighted === call.mock.url}>{@html urlWithMatchsHighlighted}</span>
                </div>
                {/if}
                <div>
                    <label for="mockStatus">Status:</label>
                    <input id="mockStatus" type="text" bind:value={call.mock.status}>
                </div>
                <div>
                    <p><label for="mockHeaders">Response headers</label></p>
                    <textarea id="mockHeaders" placeholder="{mockHeadersPlaceholder}" bind:value={call.mock.headers}></textarea>
                </div>
                <div>
                    <p><label for="mockBody">Response body</label></p>
                    <textarea id="mockBody" placeholder="{mockBodyPlaceholder}" bind:value={call.mock.body}></textarea>
                </div>
            </div>
        {/if}
    </div>

</div>

<style lang="scss">
    .regexp-success {
        color: black;
        mark {
            color: green;
        }
    }
    .error {
        color: red;
    }
    label {
        font-weight: bold;
    }
    .ks-p-32 {
        padding-left: 32px;
    }

    .ks-bg-white {
        background-color: white;
        height: 100%;
    }

    .ks-call {
        position: fixed;
        left: 150px;
        width: 100%;
        background-color: #f2f2f2;
        border: 1px solid #aaa;

        .ks-accordion {
            color: #666666;
            font-weight: bold;
            cursor: pointer;
            &:before {
                content: '\25B8';
                font-size: 18px;
                padding: 0 4px;
            }
            &.active:before {
                content: '\25BE';
            }
        }

        .ks-tabs {
            border-bottom: 1px solid #aaa;

            .ks-close {
                width: 16px;
                height: 16px;
                display: inline-flex;
                justify-content: center;
                align-items: center;
                cursor: pointer;
                margin-left: 4px;

                &:hover {
                    background-color: #dc8888;
                    border-radius: 8px;
                    color: white;
                }
            }

            .ks-tab {
                display: inline-block;
                cursor: pointer;
                padding: 0 14px;
                &.active {
                    border-bottom: 2px solid #1e90ff;
                }
                &.mock-active {
                    color: #1ead1e;
                }
            }
        }

        .ks-content {
            height: 160px;
            overflow: scroll;

            .ks-headers {
                background-color: white;
            }
        }
    }

</style>
